/*
 * Copyright (C) 2019-2021 Ashar Khan <ashar786khan@gmail.com>
 *
 * This file is part of CP Editor.
 *
 * CP Editor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * I will not be responsible if CP Editor behaves in unexpected way and
 * causes your ratings to go down and or lose any important contest.
 *
 * Believe Software is "Software" and it isn't immune to bugs.
 *
 */

/*
 * This file is auto generated by src/Settings/genSettings.py
 */

#ifndef SETTINGSHELPER_HPP
#define SETTINGSHELPER_HPP

#include "Settings/SettingsManager.hpp"
#include <QFont>
#include <QRect>
#include <QVariant>

namespace SettingsHelper
{
    inline void setTabWidth(int value) { SettingsManager::set("Tab Width", value); }
    inline int getTabWidth() { return SettingsManager::get("Tab Width").value<int>(); }
    inline QString pathOfTabWidth(bool parent = false) { return SettingsManager::getPathText("Tab Width", parent); }
    inline void setCursorWidth(int value) { SettingsManager::set("Cursor Width", value); }
    inline int getCursorWidth() { return SettingsManager::get("Cursor Width").value<int>(); }
    inline QString pathOfCursorWidth(bool parent = false) { return SettingsManager::getPathText("Cursor Width", parent); }
    inline void setGeometry(QRect value) { SettingsManager::set("Geometry", value); }
    inline QRect getGeometry() { return SettingsManager::get("Geometry").value<QRect>(); }
    inline QString pathOfGeometry(bool parent = false) { return SettingsManager::getPathText("Geometry", parent); }
    inline void setEditorFont(QFont value) { SettingsManager::set("Editor Font", value); }
    inline QFont getEditorFont() { return SettingsManager::get("Editor Font").value<QFont>(); }
    inline QString pathOfEditorFont(bool parent = false) { return SettingsManager::getPathText("Editor Font", parent); }
    inline void setUseCustomApplicationFont(bool value) { SettingsManager::set("Use Custom Application Font", value); }
    inline bool isUseCustomApplicationFont() { return SettingsManager::get("Use Custom Application Font").toBool(); }
    inline QString pathOfUseCustomApplicationFont(bool parent = false) { return SettingsManager::getPathText("Use Custom Application Font", parent); }
    inline void setCustomApplicationFont(QFont value) { SettingsManager::set("Custom Application Font", value); }
    inline QFont getCustomApplicationFont() { return SettingsManager::get("Custom Application Font").value<QFont>(); }
    inline QString pathOfCustomApplicationFont(bool parent = false) { return SettingsManager::getPathText("Custom Application Font", parent); }
    inline void setDefaultLanguage(QString value) { SettingsManager::set("Default Language", value); }
    inline QString getDefaultLanguage() { return SettingsManager::get("Default Language").value<QString>(); }
    inline QString pathOfDefaultLanguage(bool parent = false) { return SettingsManager::getPathText("Default Language", parent); }
    inline void setClangFormatProgram(QString value) { SettingsManager::set("Clang Format/Program", value); }
    inline QString getClangFormatProgram() { return SettingsManager::get("Clang Format/Program").value<QString>(); }
    inline QString pathOfClangFormatProgram(bool parent = false) { return SettingsManager::getPathText("Clang Format/Program", parent); }
    inline void setClangFormatArguments(QString value) { SettingsManager::set("Clang Format/Arguments", value); }
    inline QString getClangFormatArguments() { return SettingsManager::get("Clang Format/Arguments").value<QString>(); }
    inline QString pathOfClangFormatArguments(bool parent = false) { return SettingsManager::getPathText("Clang Format/Arguments", parent); }
    inline void setClangFormatStyle(QString value) { SettingsManager::set("Clang Format/Style", value); }
    inline QString getClangFormatStyle() { return SettingsManager::get("Clang Format/Style").value<QString>(); }
    inline QString pathOfClangFormatStyle(bool parent = false) { return SettingsManager::getPathText("Clang Format/Style", parent); }
    inline void setYAPFProgram(QString value) { SettingsManager::set("YAPF/Program", value); }
    inline QString getYAPFProgram() { return SettingsManager::get("YAPF/Program").value<QString>(); }
    inline QString pathOfYAPFProgram(bool parent = false) { return SettingsManager::getPathText("YAPF/Program", parent); }
    inline void setYAPFArguments(QString value) { SettingsManager::set("YAPF/Arguments", value); }
    inline QString getYAPFArguments() { return SettingsManager::get("YAPF/Arguments").value<QString>(); }
    inline QString pathOfYAPFArguments(bool parent = false) { return SettingsManager::getPathText("YAPF/Arguments", parent); }
    inline void setYAPFStyle(QString value) { SettingsManager::set("YAPF/Style", value); }
    inline QString getYAPFStyle() { return SettingsManager::get("YAPF/Style").value<QString>(); }
    inline QString pathOfYAPFStyle(bool parent = false) { return SettingsManager::getPathText("YAPF/Style", parent); }
    inline void setFormatOnManualSave(bool value) { SettingsManager::set("Format On Manual Save", value); }
    inline bool isFormatOnManualSave() { return SettingsManager::get("Format On Manual Save").toBool(); }
    inline QString pathOfFormatOnManualSave(bool parent = false) { return SettingsManager::getPathText("Format On Manual Save", parent); }
    inline void setFormatOnAutoSave(bool value) { SettingsManager::set("Format On Auto Save", value); }
    inline bool isFormatOnAutoSave() { return SettingsManager::get("Format On Auto Save").toBool(); }
    inline QString pathOfFormatOnAutoSave(bool parent = false) { return SettingsManager::getPathText("Format On Auto Save", parent); }
    inline void setCppTemplatePath(QString value) { SettingsManager::set("C++/Template Path", value); }
    inline QString getCppTemplatePath() { return SettingsManager::get("C++/Template Path").value<QString>(); }
    inline QString pathOfCppTemplatePath(bool parent = false) { return SettingsManager::getPathText("C++/Template Path", parent); }
    inline void setCppTemplateCursorPositionRegex(QString value) { SettingsManager::set("C++/Template Cursor Position Regex", value); }
    inline QString getCppTemplateCursorPositionRegex() { return SettingsManager::get("C++/Template Cursor Position Regex").value<QString>(); }
    inline QString pathOfCppTemplateCursorPositionRegex(bool parent = false) { return SettingsManager::getPathText("C++/Template Cursor Position Regex", parent); }
    inline void setCppTemplateCursorPositionOffsetType(QString value) { SettingsManager::set("C++/Template Cursor Position Offset Type", value); }
    inline QString getCppTemplateCursorPositionOffsetType() { return SettingsManager::get("C++/Template Cursor Position Offset Type").value<QString>(); }
    inline QString pathOfCppTemplateCursorPositionOffsetType(bool parent = false) { return SettingsManager::getPathText("C++/Template Cursor Position Offset Type", parent); }
    inline void setCppTemplateCursorPositionOffsetCharacters(int value) { SettingsManager::set("C++/Template Cursor Position Offset Characters", value); }
    inline int getCppTemplateCursorPositionOffsetCharacters() { return SettingsManager::get("C++/Template Cursor Position Offset Characters").value<int>(); }
    inline QString pathOfCppTemplateCursorPositionOffsetCharacters(bool parent = false) { return SettingsManager::getPathText("C++/Template Cursor Position Offset Characters", parent); }
    inline void setCppCompileCommand(QString value) { SettingsManager::set("C++/Compile Command", value); }
    inline QString getCppCompileCommand() { return SettingsManager::get("C++/Compile Command").value<QString>(); }
    inline QString pathOfCppCompileCommand(bool parent = false) { return SettingsManager::getPathText("C++/Compile Command", parent); }
    inline void setCppOutputPath(QString value) { SettingsManager::set("C++/Output Path", value); }
    inline QString getCppOutputPath() { return SettingsManager::get("C++/Output Path").value<QString>(); }
    inline QString pathOfCppOutputPath(bool parent = false) { return SettingsManager::getPathText("C++/Output Path", parent); }
    inline void setCppRunArguments(QString value) { SettingsManager::set("C++/Run Arguments", value); }
    inline QString getCppRunArguments() { return SettingsManager::get("C++/Run Arguments").value<QString>(); }
    inline QString pathOfCppRunArguments(bool parent = false) { return SettingsManager::getPathText("C++/Run Arguments", parent); }
    inline void setCppParentheses(QVariantList value) { SettingsManager::set("C++/Parentheses", value); }
    inline QVariantList getCppParentheses() { return SettingsManager::get("C++/Parentheses").value<QVariantList>(); }
    inline QString pathOfCppParentheses(bool parent = false) { return SettingsManager::getPathText("C++/Parentheses", parent); }
    inline void setJavaTemplatePath(QString value) { SettingsManager::set("Java/Template Path", value); }
    inline QString getJavaTemplatePath() { return SettingsManager::get("Java/Template Path").value<QString>(); }
    inline QString pathOfJavaTemplatePath(bool parent = false) { return SettingsManager::getPathText("Java/Template Path", parent); }
    inline void setJavaCompileCommand(QString value) { SettingsManager::set("Java/Compile Command", value); }
    inline QString getJavaCompileCommand() { return SettingsManager::get("Java/Compile Command").value<QString>(); }
    inline QString pathOfJavaCompileCommand(bool parent = false) { return SettingsManager::getPathText("Java/Compile Command", parent); }
    inline void setJavaRunArguments(QString value) { SettingsManager::set("Java/Run Arguments", value); }
    inline QString getJavaRunArguments() { return SettingsManager::get("Java/Run Arguments").value<QString>(); }
    inline QString pathOfJavaRunArguments(bool parent = false) { return SettingsManager::getPathText("Java/Run Arguments", parent); }
    inline void setJavaRunCommand(QString value) { SettingsManager::set("Java/Run Command", value); }
    inline QString getJavaRunCommand() { return SettingsManager::get("Java/Run Command").value<QString>(); }
    inline QString pathOfJavaRunCommand(bool parent = false) { return SettingsManager::getPathText("Java/Run Command", parent); }
    inline void setJavaClassName(QString value) { SettingsManager::set("Java/Class Name", value); }
    inline QString getJavaClassName() { return SettingsManager::get("Java/Class Name").value<QString>(); }
    inline QString pathOfJavaClassName(bool parent = false) { return SettingsManager::getPathText("Java/Class Name", parent); }
    inline void setJavaOutputPath(QString value) { SettingsManager::set("Java/Output Path", value); }
    inline QString getJavaOutputPath() { return SettingsManager::get("Java/Output Path").value<QString>(); }
    inline QString pathOfJavaOutputPath(bool parent = false) { return SettingsManager::getPathText("Java/Output Path", parent); }
    inline void setJavaTemplateCursorPositionRegex(QString value) { SettingsManager::set("Java/Template Cursor Position Regex", value); }
    inline QString getJavaTemplateCursorPositionRegex() { return SettingsManager::get("Java/Template Cursor Position Regex").value<QString>(); }
    inline QString pathOfJavaTemplateCursorPositionRegex(bool parent = false) { return SettingsManager::getPathText("Java/Template Cursor Position Regex", parent); }
    inline void setJavaTemplateCursorPositionOffsetType(QString value) { SettingsManager::set("Java/Template Cursor Position Offset Type", value); }
    inline QString getJavaTemplateCursorPositionOffsetType() { return SettingsManager::get("Java/Template Cursor Position Offset Type").value<QString>(); }
    inline QString pathOfJavaTemplateCursorPositionOffsetType(bool parent = false) { return SettingsManager::getPathText("Java/Template Cursor Position Offset Type", parent); }
    inline void setJavaTemplateCursorPositionOffsetCharacters(int value) { SettingsManager::set("Java/Template Cursor Position Offset Characters", value); }
    inline int getJavaTemplateCursorPositionOffsetCharacters() { return SettingsManager::get("Java/Template Cursor Position Offset Characters").value<int>(); }
    inline QString pathOfJavaTemplateCursorPositionOffsetCharacters(bool parent = false) { return SettingsManager::getPathText("Java/Template Cursor Position Offset Characters", parent); }
    inline void setJavaParentheses(QVariantList value) { SettingsManager::set("Java/Parentheses", value); }
    inline QVariantList getJavaParentheses() { return SettingsManager::get("Java/Parentheses").value<QVariantList>(); }
    inline QString pathOfJavaParentheses(bool parent = false) { return SettingsManager::getPathText("Java/Parentheses", parent); }
    inline void setPythonTemplatePath(QString value) { SettingsManager::set("Python/Template Path", value); }
    inline QString getPythonTemplatePath() { return SettingsManager::get("Python/Template Path").value<QString>(); }
    inline QString pathOfPythonTemplatePath(bool parent = false) { return SettingsManager::getPathText("Python/Template Path", parent); }
    inline void setPythonTemplateCursorPositionRegex(QString value) { SettingsManager::set("Python/Template Cursor Position Regex", value); }
    inline QString getPythonTemplateCursorPositionRegex() { return SettingsManager::get("Python/Template Cursor Position Regex").value<QString>(); }
    inline QString pathOfPythonTemplateCursorPositionRegex(bool parent = false) { return SettingsManager::getPathText("Python/Template Cursor Position Regex", parent); }
    inline void setPythonTemplateCursorPositionOffsetType(QString value) { SettingsManager::set("Python/Template Cursor Position Offset Type", value); }
    inline QString getPythonTemplateCursorPositionOffsetType() { return SettingsManager::get("Python/Template Cursor Position Offset Type").value<QString>(); }
    inline QString pathOfPythonTemplateCursorPositionOffsetType(bool parent = false) { return SettingsManager::getPathText("Python/Template Cursor Position Offset Type", parent); }
    inline void setPythonTemplateCursorPositionOffsetCharacters(int value) { SettingsManager::set("Python/Template Cursor Position Offset Characters", value); }
    inline int getPythonTemplateCursorPositionOffsetCharacters() { return SettingsManager::get("Python/Template Cursor Position Offset Characters").value<int>(); }
    inline QString pathOfPythonTemplateCursorPositionOffsetCharacters(bool parent = false) { return SettingsManager::getPathText("Python/Template Cursor Position Offset Characters", parent); }
    inline void setPythonRunArguments(QString value) { SettingsManager::set("Python/Run Arguments", value); }
    inline QString getPythonRunArguments() { return SettingsManager::get("Python/Run Arguments").value<QString>(); }
    inline QString pathOfPythonRunArguments(bool parent = false) { return SettingsManager::getPathText("Python/Run Arguments", parent); }
    inline void setPythonRunCommand(QString value) { SettingsManager::set("Python/Run Command", value); }
    inline QString getPythonRunCommand() { return SettingsManager::get("Python/Run Command").value<QString>(); }
    inline QString pathOfPythonRunCommand(bool parent = false) { return SettingsManager::getPathText("Python/Run Command", parent); }
    inline void setPythonParentheses(QVariantList value) { SettingsManager::set("Python/Parentheses", value); }
    inline QVariantList getPythonParentheses() { return SettingsManager::get("Python/Parentheses").value<QVariantList>(); }
    inline QString pathOfPythonParentheses(bool parent = false) { return SettingsManager::getPathText("Python/Parentheses", parent); }
    inline void setEditorTheme(QString value) { SettingsManager::set("Editor Theme", value); }
    inline QString getEditorTheme() { return SettingsManager::get("Editor Theme").value<QString>(); }
    inline QString pathOfEditorTheme(bool parent = false) { return SettingsManager::getPathText("Editor Theme", parent); }
    inline void setHighlightErrorLine(bool value) { SettingsManager::set("Highlight Error Line", value); }
    inline bool isHighlightErrorLine() { return SettingsManager::get("Highlight Error Line").toBool(); }
    inline QString pathOfHighlightErrorLine(bool parent = false) { return SettingsManager::getPathText("Highlight Error Line", parent); }
    inline void setDetachedRunTerminalProgram(QString value) { SettingsManager::set("Detached Run Terminal Program", value); }
    inline QString getDetachedRunTerminalProgram() { return SettingsManager::get("Detached Run Terminal Program").value<QString>(); }
    inline QString pathOfDetachedRunTerminalProgram(bool parent = false) { return SettingsManager::getPathText("Detached Run Terminal Program", parent); }
    inline void setDetachedRunTerminalArguments(QString value) { SettingsManager::set("Detached Run Terminal Arguments", value); }
    inline QString getDetachedRunTerminalArguments() { return SettingsManager::get("Detached Run Terminal Arguments").value<QString>(); }
    inline QString pathOfDetachedRunTerminalArguments(bool parent = false) { return SettingsManager::getPathText("Detached Run Terminal Arguments", parent); }
    inline void setAutoCompleteParentheses(bool value) { SettingsManager::set("Auto Complete Parentheses", value); }
    inline bool isAutoCompleteParentheses() { return SettingsManager::get("Auto Complete Parentheses").toBool(); }
    inline QString pathOfAutoCompleteParentheses(bool parent = false) { return SettingsManager::getPathText("Auto Complete Parentheses", parent); }
    inline void setAutoRemoveParentheses(bool value) { SettingsManager::set("Auto Remove Parentheses", value); }
    inline bool isAutoRemoveParentheses() { return SettingsManager::get("Auto Remove Parentheses").toBool(); }
    inline QString pathOfAutoRemoveParentheses(bool parent = false) { return SettingsManager::getPathText("Auto Remove Parentheses", parent); }
    inline void setTabJumpOutParentheses(bool value) { SettingsManager::set("Tab Jump Out Parentheses", value); }
    inline bool isTabJumpOutParentheses() { return SettingsManager::get("Tab Jump Out Parentheses").toBool(); }
    inline QString pathOfTabJumpOutParentheses(bool parent = false) { return SettingsManager::getPathText("Tab Jump Out Parentheses", parent); }
    inline void setAutoIndent(bool value) { SettingsManager::set("Auto Indent", value); }
    inline bool isAutoIndent() { return SettingsManager::get("Auto Indent").toBool(); }
    inline QString pathOfAutoIndent(bool parent = false) { return SettingsManager::getPathText("Auto Indent", parent); }
    inline void setAutoSave(bool value) { SettingsManager::set("Auto Save", value); }
    inline bool isAutoSave() { return SettingsManager::get("Auto Save").toBool(); }
    inline QString pathOfAutoSave(bool parent = false) { return SettingsManager::getPathText("Auto Save", parent); }
    inline void setAutoSaveInterval(int value) { SettingsManager::set("Auto Save Interval", value); }
    inline int getAutoSaveInterval() { return SettingsManager::get("Auto Save Interval").value<int>(); }
    inline QString pathOfAutoSaveInterval(bool parent = false) { return SettingsManager::getPathText("Auto Save Interval", parent); }
    inline void setAutoSaveIntervalType(QString value) { SettingsManager::set("Auto Save Interval Type", value); }
    inline QString getAutoSaveIntervalType() { return SettingsManager::get("Auto Save Interval Type").value<QString>(); }
    inline QString pathOfAutoSaveIntervalType(bool parent = false) { return SettingsManager::getPathText("Auto Save Interval Type", parent); }
    inline void setWrapText(bool value) { SettingsManager::set("Wrap Text", value); }
    inline bool isWrapText() { return SettingsManager::get("Wrap Text").toBool(); }
    inline QString pathOfWrapText(bool parent = false) { return SettingsManager::getPathText("Wrap Text", parent); }
    inline void setBeta(bool value) { SettingsManager::set("Beta", value); }
    inline bool isBeta() { return SettingsManager::get("Beta").toBool(); }
    inline QString pathOfBeta(bool parent = false) { return SettingsManager::getPathText("Beta", parent); }
    inline void setReplaceTabs(bool value) { SettingsManager::set("Replace Tabs", value); }
    inline bool isReplaceTabs() { return SettingsManager::get("Replace Tabs").toBool(); }
    inline QString pathOfReplaceTabs(bool parent = false) { return SettingsManager::getPathText("Replace Tabs", parent); }
    inline void setSaveTests(bool value) { SettingsManager::set("Save Tests", value); }
    inline bool isSaveTests() { return SettingsManager::get("Save Tests").toBool(); }
    inline QString pathOfSaveTests(bool parent = false) { return SettingsManager::getPathText("Save Tests", parent); }
    inline void setMaximizedWindow(bool value) { SettingsManager::set("Maximized Window", value); }
    inline bool isMaximizedWindow() { return SettingsManager::get("Maximized Window").toBool(); }
    inline QString pathOfMaximizedWindow(bool parent = false) { return SettingsManager::getPathText("Maximized Window", parent); }
    inline void setCheckUpdate(bool value) { SettingsManager::set("Check Update", value); }
    inline bool isCheckUpdate() { return SettingsManager::get("Check Update").toBool(); }
    inline QString pathOfCheckUpdate(bool parent = false) { return SettingsManager::getPathText("Check Update", parent); }
    inline void setOpacity(int value) { SettingsManager::set("Opacity", value); }
    inline int getOpacity() { return SettingsManager::get("Opacity").value<int>(); }
    inline QString pathOfOpacity(bool parent = false) { return SettingsManager::getPathText("Opacity", parent); }
    inline void setViewMode(QString value) { SettingsManager::set("View Mode", value); }
    inline QString getViewMode() { return SettingsManager::get("View Mode").value<QString>(); }
    inline QString pathOfViewMode(bool parent = false) { return SettingsManager::getPathText("View Mode", parent); }
    inline void setSplitterSize(QByteArray value) { SettingsManager::set("Splitter Size", value); }
    inline QByteArray getSplitterSize() { return SettingsManager::get("Splitter Size").value<QByteArray>(); }
    inline QString pathOfSplitterSize(bool parent = false) { return SettingsManager::getPathText("Splitter Size", parent); }
    inline void setRightSplitterSize(QByteArray value) { SettingsManager::set("Right Splitter Size", value); }
    inline QByteArray getRightSplitterSize() { return SettingsManager::get("Right Splitter Size").value<QByteArray>(); }
    inline QString pathOfRightSplitterSize(bool parent = false) { return SettingsManager::getPathText("Right Splitter Size", parent); }
    inline void setCompetitiveCompanionEnable(bool value) { SettingsManager::set("Competitive Companion/Enable", value); }
    inline bool isCompetitiveCompanionEnable() { return SettingsManager::get("Competitive Companion/Enable").toBool(); }
    inline QString pathOfCompetitiveCompanionEnable(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Enable", parent); }
    inline void setCompetitiveCompanionConnectionPort(int value) { SettingsManager::set("Competitive Companion/Connection Port", value); }
    inline int getCompetitiveCompanionConnectionPort() { return SettingsManager::get("Competitive Companion/Connection Port").value<int>(); }
    inline QString pathOfCompetitiveCompanionConnectionPort(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Connection Port", parent); }
    inline void setCompetitiveCompanionOpenNewTab(bool value) { SettingsManager::set("Competitive Companion/Open New Tab", value); }
    inline bool isCompetitiveCompanionOpenNewTab() { return SettingsManager::get("Competitive Companion/Open New Tab").toBool(); }
    inline QString pathOfCompetitiveCompanionOpenNewTab(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Open New Tab", parent); }
    inline void setCompetitiveCompanionSetTimeLimitForTab(bool value) { SettingsManager::set("Competitive Companion/Set Time Limit For Tab", value); }
    inline bool isCompetitiveCompanionSetTimeLimitForTab() { return SettingsManager::get("Competitive Companion/Set Time Limit For Tab").toBool(); }
    inline QString pathOfCompetitiveCompanionSetTimeLimitForTab(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Set Time Limit For Tab", parent); }
    inline void setCompetitiveCompanionHeadComments(QString value) { SettingsManager::set("Competitive Companion/Head Comments", value); }
    inline QString getCompetitiveCompanionHeadComments() { return SettingsManager::get("Competitive Companion/Head Comments").value<QString>(); }
    inline QString pathOfCompetitiveCompanionHeadComments(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Head Comments", parent); }
    inline void setCompetitiveCompanionHeadCommentsTimeFormat(QString value) { SettingsManager::set("Competitive Companion/Head Comments Time Format", value); }
    inline QString getCompetitiveCompanionHeadCommentsTimeFormat() { return SettingsManager::get("Competitive Companion/Head Comments Time Format").value<QString>(); }
    inline QString pathOfCompetitiveCompanionHeadCommentsTimeFormat(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Head Comments Time Format", parent); }
    inline void setCompetitiveCompanionHeadCommentsPoweredByCPEditor(bool value) { SettingsManager::set("Competitive Companion/Head Comments Powered By CP Editor", value); }
    inline bool isCompetitiveCompanionHeadCommentsPoweredByCPEditor() { return SettingsManager::get("Competitive Companion/Head Comments Powered By CP Editor").toBool(); }
    inline QString pathOfCompetitiveCompanionHeadCommentsPoweredByCPEditor(bool parent = false) { return SettingsManager::getPathText("Competitive Companion/Head Comments Powered By CP Editor", parent); }
    inline void setHotkeyFormat(QString value) { SettingsManager::set("Hotkey/Format", value); }
    inline QString getHotkeyFormat() { return SettingsManager::get("Hotkey/Format").value<QString>(); }
    inline QString pathOfHotkeyFormat(bool parent = false) { return SettingsManager::getPathText("Hotkey/Format", parent); }
    inline void setHotkeyKill(QString value) { SettingsManager::set("Hotkey/Kill", value); }
    inline QString getHotkeyKill() { return SettingsManager::get("Hotkey/Kill").value<QString>(); }
    inline QString pathOfHotkeyKill(bool parent = false) { return SettingsManager::getPathText("Hotkey/Kill", parent); }
    inline void setHotkeyCompileRun(QString value) { SettingsManager::set("Hotkey/Compile Run", value); }
    inline QString getHotkeyCompileRun() { return SettingsManager::get("Hotkey/Compile Run").value<QString>(); }
    inline QString pathOfHotkeyCompileRun(bool parent = false) { return SettingsManager::getPathText("Hotkey/Compile Run", parent); }
    inline void setHotkeyRun(QString value) { SettingsManager::set("Hotkey/Run", value); }
    inline QString getHotkeyRun() { return SettingsManager::get("Hotkey/Run").value<QString>(); }
    inline QString pathOfHotkeyRun(bool parent = false) { return SettingsManager::getPathText("Hotkey/Run", parent); }
    inline void setHotkeyCompile(QString value) { SettingsManager::set("Hotkey/Compile", value); }
    inline QString getHotkeyCompile() { return SettingsManager::get("Hotkey/Compile").value<QString>(); }
    inline QString pathOfHotkeyCompile(bool parent = false) { return SettingsManager::getPathText("Hotkey/Compile", parent); }
    inline void setHotkeyChangeViewMode(QString value) { SettingsManager::set("Hotkey/Change View Mode", value); }
    inline QString getHotkeyChangeViewMode() { return SettingsManager::get("Hotkey/Change View Mode").value<QString>(); }
    inline QString pathOfHotkeyChangeViewMode(bool parent = false) { return SettingsManager::getPathText("Hotkey/Change View Mode", parent); }
    inline void setHotkeySnippets(QString value) { SettingsManager::set("Hotkey/Snippets", value); }
    inline QString getHotkeySnippets() { return SettingsManager::get("Hotkey/Snippets").value<QString>(); }
    inline QString pathOfHotkeySnippets(bool parent = false) { return SettingsManager::getPathText("Hotkey/Snippets", parent); }
    inline void setHotExitEnable(bool value) { SettingsManager::set("Hot Exit/Enable", value); }
    inline bool isHotExitEnable() { return SettingsManager::get("Hot Exit/Enable").toBool(); }
    inline QString pathOfHotExitEnable(bool parent = false) { return SettingsManager::getPathText("Hot Exit/Enable", parent); }
    inline void setHotExitAutoSave(bool value) { SettingsManager::set("Hot Exit/Auto Save", value); }
    inline bool isHotExitAutoSave() { return SettingsManager::get("Hot Exit/Auto Save").toBool(); }
    inline QString pathOfHotExitAutoSave(bool parent = false) { return SettingsManager::getPathText("Hot Exit/Auto Save", parent); }
    inline void setHotExitAutoSaveInterval(int value) { SettingsManager::set("Hot Exit/Auto Save Interval", value); }
    inline int getHotExitAutoSaveInterval() { return SettingsManager::get("Hot Exit/Auto Save Interval").value<int>(); }
    inline QString pathOfHotExitAutoSaveInterval(bool parent = false) { return SettingsManager::getPathText("Hot Exit/Auto Save Interval", parent); }
    inline void setForceClose(bool value) { SettingsManager::set("Force Close", value); }
    inline bool isForceClose() { return SettingsManager::get("Force Close").toBool(); }
    inline QString pathOfForceClose(bool parent = false) { return SettingsManager::getPathText("Force Close", parent); }
    inline void setCFPath(QString value) { SettingsManager::set("CF/Path", value); }
    inline QString getCFPath() { return SettingsManager::get("CF/Path").value<QString>(); }
    inline QString pathOfCFPath(bool parent = false) { return SettingsManager::getPathText("CF/Path", parent); }
    inline void setCFShowToastMessages(bool value) { SettingsManager::set("CF/Show Toast Messages", value); }
    inline bool isCFShowToastMessages() { return SettingsManager::get("CF/Show Toast Messages").toBool(); }
    inline QString pathOfCFShowToastMessages(bool parent = false) { return SettingsManager::getPathText("CF/Show Toast Messages", parent); }
    inline void setShowCompileAndRunOnly(bool value) { SettingsManager::set("Show Compile And Run Only", value); }
    inline bool isShowCompileAndRunOnly() { return SettingsManager::get("Show Compile And Run Only").toBool(); }
    inline QString pathOfShowCompileAndRunOnly(bool parent = false) { return SettingsManager::getPathText("Show Compile And Run Only", parent); }
    inline void setDisplayEOLNInDiff(bool value) { SettingsManager::set("Display EOLN In Diff", value); }
    inline bool isDisplayEOLNInDiff() { return SettingsManager::get("Display EOLN In Diff").toBool(); }
    inline QString pathOfDisplayEOLNInDiff(bool parent = false) { return SettingsManager::getPathText("Display EOLN In Diff", parent); }
    inline void setSaveFaster(bool value) { SettingsManager::set("Save Faster", value); }
    inline bool isSaveFaster() { return SettingsManager::get("Save Faster").toBool(); }
    inline QString pathOfSaveFaster(bool parent = false) { return SettingsManager::getPathText("Save Faster", parent); }
    inline void setDefaultTimeLimit(int value) { SettingsManager::set("Default Time Limit", value); }
    inline int getDefaultTimeLimit() { return SettingsManager::get("Default Time Limit").value<int>(); }
    inline QString pathOfDefaultTimeLimit(bool parent = false) { return SettingsManager::getPathText("Default Time Limit", parent); }
    inline void setOutputLengthLimit(int value) { SettingsManager::set("Output Length Limit", value); }
    inline int getOutputLengthLimit() { return SettingsManager::get("Output Length Limit").value<int>(); }
    inline QString pathOfOutputLengthLimit(bool parent = false) { return SettingsManager::getPathText("Output Length Limit", parent); }
    inline void setOutputDisplayLengthLimit(int value) { SettingsManager::set("Output Display Length Limit", value); }
    inline int getOutputDisplayLengthLimit() { return SettingsManager::get("Output Display Length Limit").value<int>(); }
    inline QString pathOfOutputDisplayLengthLimit(bool parent = false) { return SettingsManager::getPathText("Output Display Length Limit", parent); }
    inline void setMessageLengthLimit(int value) { SettingsManager::set("Message Length Limit", value); }
    inline int getMessageLengthLimit() { return SettingsManager::get("Message Length Limit").value<int>(); }
    inline QString pathOfMessageLengthLimit(bool parent = false) { return SettingsManager::getPathText("Message Length Limit", parent); }
    inline void setHTMLDiffViewerLengthLimit(int value) { SettingsManager::set("HTML Diff Viewer Length Limit", value); }
    inline int getHTMLDiffViewerLengthLimit() { return SettingsManager::get("HTML Diff Viewer Length Limit").value<int>(); }
    inline QString pathOfHTMLDiffViewerLengthLimit(bool parent = false) { return SettingsManager::getPathText("HTML Diff Viewer Length Limit", parent); }
    inline void setOpenFileLengthLimit(int value) { SettingsManager::set("Open File Length Limit", value); }
    inline int getOpenFileLengthLimit() { return SettingsManager::get("Open File Length Limit").value<int>(); }
    inline QString pathOfOpenFileLengthLimit(bool parent = false) { return SettingsManager::getPathText("Open File Length Limit", parent); }
    inline void setDisplayTestCaseLengthLimit(int value) { SettingsManager::set("Display Test Case Length Limit", value); }
    inline int getDisplayTestCaseLengthLimit() { return SettingsManager::get("Display Test Case Length Limit").value<int>(); }
    inline QString pathOfDisplayTestCaseLengthLimit(bool parent = false) { return SettingsManager::getPathText("Display Test Case Length Limit", parent); }
    inline void setLSPPathCpp(QString value) { SettingsManager::set("LSP/Path C++", value); }
    inline QString getLSPPathCpp() { return SettingsManager::get("LSP/Path C++").value<QString>(); }
    inline QString pathOfLSPPathCpp(bool parent = false) { return SettingsManager::getPathText("LSP/Path C++", parent); }
    inline void setLSPPathJava(QString value) { SettingsManager::set("LSP/Path Java", value); }
    inline QString getLSPPathJava() { return SettingsManager::get("LSP/Path Java").value<QString>(); }
    inline QString pathOfLSPPathJava(bool parent = false) { return SettingsManager::getPathText("LSP/Path Java", parent); }
    inline void setLSPPathPython(QString value) { SettingsManager::set("LSP/Path Python", value); }
    inline QString getLSPPathPython() { return SettingsManager::get("LSP/Path Python").value<QString>(); }
    inline QString pathOfLSPPathPython(bool parent = false) { return SettingsManager::getPathText("LSP/Path Python", parent); }
    inline void setLSPUseLintingCpp(bool value) { SettingsManager::set("LSP/Use Linting C++", value); }
    inline bool isLSPUseLintingCpp() { return SettingsManager::get("LSP/Use Linting C++").toBool(); }
    inline QString pathOfLSPUseLintingCpp(bool parent = false) { return SettingsManager::getPathText("LSP/Use Linting C++", parent); }
    inline void setLSPUseLintingJava(bool value) { SettingsManager::set("LSP/Use Linting Java", value); }
    inline bool isLSPUseLintingJava() { return SettingsManager::get("LSP/Use Linting Java").toBool(); }
    inline QString pathOfLSPUseLintingJava(bool parent = false) { return SettingsManager::getPathText("LSP/Use Linting Java", parent); }
    inline void setLSPUseLintingPython(bool value) { SettingsManager::set("LSP/Use Linting Python", value); }
    inline bool isLSPUseLintingPython() { return SettingsManager::get("LSP/Use Linting Python").toBool(); }
    inline QString pathOfLSPUseLintingPython(bool parent = false) { return SettingsManager::getPathText("LSP/Use Linting Python", parent); }
    inline void setLSPUseAutocompleteCpp(bool value) { SettingsManager::set("LSP/Use Autocomplete C++", value); }
    inline bool isLSPUseAutocompleteCpp() { return SettingsManager::get("LSP/Use Autocomplete C++").toBool(); }
    inline QString pathOfLSPUseAutocompleteCpp(bool parent = false) { return SettingsManager::getPathText("LSP/Use Autocomplete C++", parent); }
    inline void setLSPUseAutocompleteJava(bool value) { SettingsManager::set("LSP/Use Autocomplete Java", value); }
    inline bool isLSPUseAutocompleteJava() { return SettingsManager::get("LSP/Use Autocomplete Java").toBool(); }
    inline QString pathOfLSPUseAutocompleteJava(bool parent = false) { return SettingsManager::getPathText("LSP/Use Autocomplete Java", parent); }
    inline void setLSPUseAutocompletePython(bool value) { SettingsManager::set("LSP/Use Autocomplete Python", value); }
    inline bool isLSPUseAutocompletePython() { return SettingsManager::get("LSP/Use Autocomplete Python").toBool(); }
    inline QString pathOfLSPUseAutocompletePython(bool parent = false) { return SettingsManager::getPathText("LSP/Use Autocomplete Python", parent); }
    inline void setLSPDelayCpp(int value) { SettingsManager::set("LSP/Delay C++", value); }
    inline int getLSPDelayCpp() { return SettingsManager::get("LSP/Delay C++").value<int>(); }
    inline QString pathOfLSPDelayCpp(bool parent = false) { return SettingsManager::getPathText("LSP/Delay C++", parent); }
    inline void setLSPDelayJava(int value) { SettingsManager::set("LSP/Delay Java", value); }
    inline int getLSPDelayJava() { return SettingsManager::get("LSP/Delay Java").value<int>(); }
    inline QString pathOfLSPDelayJava(bool parent = false) { return SettingsManager::getPathText("LSP/Delay Java", parent); }
    inline void setLSPDelayPython(int value) { SettingsManager::set("LSP/Delay Python", value); }
    inline int getLSPDelayPython() { return SettingsManager::get("LSP/Delay Python").value<int>(); }
    inline QString pathOfLSPDelayPython(bool parent = false) { return SettingsManager::getPathText("LSP/Delay Python", parent); }
    inline void setLSPArgsCpp(QString value) { SettingsManager::set("LSP/Args C++", value); }
    inline QString getLSPArgsCpp() { return SettingsManager::get("LSP/Args C++").value<QString>(); }
    inline QString pathOfLSPArgsCpp(bool parent = false) { return SettingsManager::getPathText("LSP/Args C++", parent); }
    inline void setLSPArgsJava(QString value) { SettingsManager::set("LSP/Args Java", value); }
    inline QString getLSPArgsJava() { return SettingsManager::get("LSP/Args Java").value<QString>(); }
    inline QString pathOfLSPArgsJava(bool parent = false) { return SettingsManager::getPathText("LSP/Args Java", parent); }
    inline void setLSPArgsPython(QString value) { SettingsManager::set("LSP/Args Python", value); }
    inline QString getLSPArgsPython() { return SettingsManager::get("LSP/Args Python").value<QString>(); }
    inline QString pathOfLSPArgsPython(bool parent = false) { return SettingsManager::getPathText("LSP/Args Python", parent); }
    inline void setTestcasesMatchingRules(QVariantList value) { SettingsManager::set("Testcases Matching Rules", value); }
    inline QVariantList getTestcasesMatchingRules() { return SettingsManager::get("Testcases Matching Rules").value<QVariantList>(); }
    inline QString pathOfTestcasesMatchingRules(bool parent = false) { return SettingsManager::getPathText("Testcases Matching Rules", parent); }
    inline void setInputFileSavePath(QString value) { SettingsManager::set("Input File Save Path", value); }
    inline QString getInputFileSavePath() { return SettingsManager::get("Input File Save Path").value<QString>(); }
    inline QString pathOfInputFileSavePath(bool parent = false) { return SettingsManager::getPathText("Input File Save Path", parent); }
    inline void setAnswerFileSavePath(QString value) { SettingsManager::set("Answer File Save Path", value); }
    inline QString getAnswerFileSavePath() { return SettingsManager::get("Answer File Save Path").value<QString>(); }
    inline QString pathOfAnswerFileSavePath(bool parent = false) { return SettingsManager::getPathText("Answer File Save Path", parent); }
    inline void setDefaultFilePathsForProblemURLs(QVariantList value) { SettingsManager::set("Default File Paths For Problem URLs", value); }
    inline QVariantList getDefaultFilePathsForProblemURLs() { return SettingsManager::get("Default File Paths For Problem URLs").value<QVariantList>(); }
    inline QString pathOfDefaultFilePathsForProblemURLs(bool parent = false) { return SettingsManager::getPathText("Default File Paths For Problem URLs", parent); }
    inline void setTestCasesFont(QFont value) { SettingsManager::set("Test Cases Font", value); }
    inline QFont getTestCasesFont() { return SettingsManager::get("Test Cases Font").value<QFont>(); }
    inline QString pathOfTestCasesFont(bool parent = false) { return SettingsManager::getPathText("Test Cases Font", parent); }
    inline void setExtraBottomMargin(bool value) { SettingsManager::set("Extra Bottom Margin", value); }
    inline bool isExtraBottomMargin() { return SettingsManager::get("Extra Bottom Margin").toBool(); }
    inline QString pathOfExtraBottomMargin(bool parent = false) { return SettingsManager::getPathText("Extra Bottom Margin", parent); }
    inline void setMessageLoggerFont(QFont value) { SettingsManager::set("Message Logger Font", value); }
    inline QFont getMessageLoggerFont() { return SettingsManager::get("Message Logger Font").value<QFont>(); }
    inline QString pathOfMessageLoggerFont(bool parent = false) { return SettingsManager::getPathText("Message Logger Font", parent); }
    inline void setSaveFileOnCompilation(bool value) { SettingsManager::set("Save File On Compilation", value); }
    inline bool isSaveFileOnCompilation() { return SettingsManager::get("Save File On Compilation").toBool(); }
    inline QString pathOfSaveFileOnCompilation(bool parent = false) { return SettingsManager::getPathText("Save File On Compilation", parent); }
    inline void setSaveFileOnExecution(bool value) { SettingsManager::set("Save File On Execution", value); }
    inline bool isSaveFileOnExecution() { return SettingsManager::get("Save File On Execution").toBool(); }
    inline QString pathOfSaveFileOnExecution(bool parent = false) { return SettingsManager::getPathText("Save File On Execution", parent); }
    inline void setRestoreOldProblemUrl(bool value) { SettingsManager::set("Restore Old Problem Url", value); }
    inline bool isRestoreOldProblemUrl() { return SettingsManager::get("Restore Old Problem Url").toBool(); }
    inline QString pathOfRestoreOldProblemUrl(bool parent = false) { return SettingsManager::getPathText("Restore Old Problem Url", parent); }
    inline void setOpenOldFileForOldProblemUrl(bool value) { SettingsManager::set("Open Old File For Old Problem Url", value); }
    inline bool isOpenOldFileForOldProblemUrl() { return SettingsManager::get("Open Old File For Old Problem Url").toBool(); }
    inline QString pathOfOpenOldFileForOldProblemUrl(bool parent = false) { return SettingsManager::getPathText("Open Old File For Old Problem Url", parent); }
    inline void setLocale(QString value) { SettingsManager::set("Locale", value); }
    inline QString getLocale() { return SettingsManager::get("Locale").value<QString>(); }
    inline QString pathOfLocale(bool parent = false) { return SettingsManager::getPathText("Locale", parent); }
    inline void setUIStyle(QString value) { SettingsManager::set("UI Style", value); }
    inline QString getUIStyle() { return SettingsManager::get("UI Style").value<QString>(); }
    inline QString pathOfUIStyle(bool parent = false) { return SettingsManager::getPathText("UI Style", parent); }
    struct LanguageConfig {
        QString pre;
        LanguageConfig(QString p) : pre(p) {}
        inline void setSnippet(QString key, QString data) { SettingsManager::set(QStringList {pre,  "Snippet", key}.join('/'), data); }
        inline void removeSnippet(QString key) { SettingsManager::remove({QStringList {pre,  "Snippet", key}.join('/')}); }
        inline QString getSnippet(QString key) { return SettingsManager::get(QStringList {pre,  "Snippet", key}.join('/')).value<QString>(); }
        inline QStringList getSnippets() { return SettingsManager::itemUnder(QStringList {pre,  "Snippet"}.join('/') + '/'); }
        inline QString pathOfSnippet(bool parent = false) { return SettingsManager::getPathText("Snippet", parent); }
    };
    inline LanguageConfig getLanguageConfig(QString key) { return LanguageConfig(QStringList { "Language Config", key}.join('/')); }
    inline void removeLanguageConfig(QString key) { SettingsManager::remove(SettingsManager::keyStartsWith(QStringList { "Language Config", key}.join('/'))); }
    inline QStringList queryLanguageConfig() { return SettingsManager::itemUnder(QStringList { "Language Config"}.join('/') + '/'); }
    inline QString pathOfLanguageConfig(bool parent = false) { return SettingsManager::getPathText("Language Config", parent); }
    inline void setRunOnEmptyTestcase(bool value) { SettingsManager::set("Run On Empty Testcase", value); }
    inline bool isRunOnEmptyTestcase() { return SettingsManager::get("Run On Empty Testcase").toBool(); }
    inline QString pathOfRunOnEmptyTestcase(bool parent = false) { return SettingsManager::getPathText("Run On Empty Testcase", parent); }
    inline void setCheckOnTestcasesWithEmptyOutput(bool value) { SettingsManager::set("Check On Testcases With Empty Output", value); }
    inline bool isCheckOnTestcasesWithEmptyOutput() { return SettingsManager::get("Check On Testcases With Empty Output").toBool(); }
    inline QString pathOfCheckOnTestcasesWithEmptyOutput(bool parent = false) { return SettingsManager::getPathText("Check On Testcases With Empty Output", parent); }
    inline void setTestCaseMaximumHeight(int value) { SettingsManager::set("Test Case Maximum Height", value); }
    inline int getTestCaseMaximumHeight() { return SettingsManager::get("Test Case Maximum Height").value<int>(); }
    inline QString pathOfTestCaseMaximumHeight(bool parent = false) { return SettingsManager::getPathText("Test Case Maximum Height", parent); }
    inline void setProxyEnabled(bool value) { SettingsManager::set("Proxy/Enabled", value); }
    inline bool isProxyEnabled() { return SettingsManager::get("Proxy/Enabled").toBool(); }
    inline QString pathOfProxyEnabled(bool parent = false) { return SettingsManager::getPathText("Proxy/Enabled", parent); }
    inline void setProxyType(QString value) { SettingsManager::set("Proxy/Type", value); }
    inline QString getProxyType() { return SettingsManager::get("Proxy/Type").value<QString>(); }
    inline QString pathOfProxyType(bool parent = false) { return SettingsManager::getPathText("Proxy/Type", parent); }
    inline void setProxyHostName(QString value) { SettingsManager::set("Proxy/Host Name", value); }
    inline QString getProxyHostName() { return SettingsManager::get("Proxy/Host Name").value<QString>(); }
    inline QString pathOfProxyHostName(bool parent = false) { return SettingsManager::getPathText("Proxy/Host Name", parent); }
    inline void setProxyPort(int value) { SettingsManager::set("Proxy/Port", value); }
    inline int getProxyPort() { return SettingsManager::get("Proxy/Port").value<int>(); }
    inline QString pathOfProxyPort(bool parent = false) { return SettingsManager::getPathText("Proxy/Port", parent); }
    inline void setProxyUser(QString value) { SettingsManager::set("Proxy/User", value); }
    inline QString getProxyUser() { return SettingsManager::get("Proxy/User").value<QString>(); }
    inline QString pathOfProxyUser(bool parent = false) { return SettingsManager::getPathText("Proxy/User", parent); }
    inline void setProxyPassword(QString value) { SettingsManager::set("Proxy/Password", value); }
    inline QString getProxyPassword() { return SettingsManager::get("Proxy/Password").value<QString>(); }
    inline QString pathOfProxyPassword(bool parent = false) { return SettingsManager::getPathText("Proxy/Password", parent); }
    inline void setCppCompilerOutputCodec(QString value) { SettingsManager::set("C++/Compiler Output Codec", value); }
    inline QString getCppCompilerOutputCodec() { return SettingsManager::get("C++/Compiler Output Codec").value<QString>(); }
    inline QString pathOfCppCompilerOutputCodec(bool parent = false) { return SettingsManager::getPathText("C++/Compiler Output Codec", parent); }
    inline void setJavaCompilerOutputCodec(QString value) { SettingsManager::set("Java/Compiler Output Codec", value); }
    inline QString getJavaCompilerOutputCodec() { return SettingsManager::get("Java/Compiler Output Codec").value<QString>(); }
    inline QString pathOfJavaCompilerOutputCodec(bool parent = false) { return SettingsManager::getPathText("Java/Compiler Output Codec", parent); }
    inline void setDefaultPathNamesAndPaths(QVariantList value) { SettingsManager::set("Default Path/Names And Paths", value); }
    inline QVariantList getDefaultPathNamesAndPaths() { return SettingsManager::get("Default Path/Names And Paths").value<QVariantList>(); }
    inline QString pathOfDefaultPathNamesAndPaths(bool parent = false) { return SettingsManager::getPathText("Default Path/Names And Paths", parent); }
    inline void setAutoLoadExternalChangesIfNoUnsavedModification(bool value) { SettingsManager::set("Auto Load External Changes If No Unsaved Modification", value); }
    inline bool isAutoLoadExternalChangesIfNoUnsavedModification() { return SettingsManager::get("Auto Load External Changes If No Unsaved Modification").toBool(); }
    inline QString pathOfAutoLoadExternalChangesIfNoUnsavedModification(bool parent = false) { return SettingsManager::getPathText("Auto Load External Changes If No Unsaved Modification", parent); }
    inline void setAskForLoadingExternalChanges(bool value) { SettingsManager::set("Ask For Loading External Changes", value); }
    inline bool isAskForLoadingExternalChanges() { return SettingsManager::get("Ask For Loading External Changes").toBool(); }
    inline QString pathOfAskForLoadingExternalChanges(bool parent = false) { return SettingsManager::getPathText("Ask For Loading External Changes", parent); }
    inline void setRecentFiles(QStringList value) { SettingsManager::set("Recent Files", value); }
    inline QStringList getRecentFiles() { return SettingsManager::get("Recent Files").value<QStringList>(); }
    inline QString pathOfRecentFiles(bool parent = false) { return SettingsManager::getPathText("Recent Files", parent); }
    inline void setNumberOfProblemsInContest(int value) { SettingsManager::set("Number Of Problems In Contest", value); }
    inline int getNumberOfProblemsInContest() { return SettingsManager::get("Number Of Problems In Contest").value<int>(); }
    inline QString pathOfNumberOfProblemsInContest(bool parent = false) { return SettingsManager::getPathText("Number Of Problems In Contest", parent); }
    inline void setFirstTimeUser(bool value) { SettingsManager::set("First Time User", value); }
    inline bool isFirstTimeUser() { return SettingsManager::get("First Time User").toBool(); }
    inline QString pathOfFirstTimeUser(bool parent = false) { return SettingsManager::getPathText("First Time User", parent); }
    inline void setShowOnlyMonospacedFont(bool value) { SettingsManager::set("Show Only Monospaced Font", value); }
    inline bool isShowOnlyMonospacedFont() { return SettingsManager::get("Show Only Monospaced Font").toBool(); }
    inline QString pathOfShowOnlyMonospacedFont(bool parent = false) { return SettingsManager::getPathText("Show Only Monospaced Font", parent); }
    inline void setTotalUsageTime(int value) { SettingsManager::set("Total Usage Time", value); }
    inline int getTotalUsageTime() { return SettingsManager::get("Total Usage Time").value<int>(); }
    inline QString pathOfTotalUsageTime(bool parent = false) { return SettingsManager::getPathText("Total Usage Time", parent); }
    inline void setPromotionDialogShown(bool value) { SettingsManager::set("Promotion Dialog Shown", value); }
    inline bool isPromotionDialogShown() { return SettingsManager::get("Promotion Dialog Shown").toBool(); }
    inline QString pathOfPromotionDialogShown(bool parent = false) { return SettingsManager::getPathText("Promotion Dialog Shown", parent); }
    inline void setAutoUncheckAcceptedTestcases(bool value) { SettingsManager::set("Auto Uncheck Accepted Testcases", value); }
    inline bool isAutoUncheckAcceptedTestcases() { return SettingsManager::get("Auto Uncheck Accepted Testcases").toBool(); }
    inline QString pathOfAutoUncheckAcceptedTestcases(bool parent = false) { return SettingsManager::getPathText("Auto Uncheck Accepted Testcases", parent); }
    inline void setFullScreenDialogShown(bool value) { SettingsManager::set("Full Screen Dialog Shown", value); }
    inline bool isFullScreenDialogShown() { return SettingsManager::get("Full Screen Dialog Shown").toBool(); }
    inline QString pathOfFullScreenDialogShown(bool parent = false) { return SettingsManager::getPathText("Full Screen Dialog Shown", parent); }
    inline void setWakaTimePath(QString value) { SettingsManager::set("WakaTime/Path", value); }
    inline QString getWakaTimePath() { return SettingsManager::get("WakaTime/Path").value<QString>(); }
    inline QString pathOfWakaTimePath(bool parent = false) { return SettingsManager::getPathText("WakaTime/Path", parent); }
    inline void setWakaTimeApiKey(QString value) { SettingsManager::set("WakaTime/Api Key", value); }
    inline QString getWakaTimeApiKey() { return SettingsManager::get("WakaTime/Api Key").value<QString>(); }
    inline QString pathOfWakaTimeApiKey(bool parent = false) { return SettingsManager::getPathText("WakaTime/Api Key", parent); }
    inline void setWakaTimeEnable(bool value) { SettingsManager::set("WakaTime/Enable", value); }
    inline bool isWakaTimeEnable() { return SettingsManager::get("WakaTime/Enable").toBool(); }
    inline QString pathOfWakaTimeEnable(bool parent = false) { return SettingsManager::getPathText("WakaTime/Enable", parent); }
    inline void setWakaTimeProxy(bool value) { SettingsManager::set("WakaTime/Proxy", value); }
    inline bool isWakaTimeProxy() { return SettingsManager::get("WakaTime/Proxy").toBool(); }
    inline QString pathOfWakaTimeProxy(bool parent = false) { return SettingsManager::getPathText("WakaTime/Proxy", parent); }
    inline void setDisplayStopwatch(bool value) { SettingsManager::set("Display Stopwatch", value); }
    inline bool isDisplayStopwatch() { return SettingsManager::get("Display Stopwatch").toBool(); }
    inline QString pathOfDisplayStopwatch(bool parent = false) { return SettingsManager::getPathText("Display Stopwatch", parent); }
    inline void setToggleStopwatchOnTabSwitch(bool value) { SettingsManager::set("Toggle Stopwatch On Tab Switch", value); }
    inline bool isToggleStopwatchOnTabSwitch() { return SettingsManager::get("Toggle Stopwatch On Tab Switch").toBool(); }
    inline QString pathOfToggleStopwatchOnTabSwitch(bool parent = false) { return SettingsManager::getPathText("Toggle Stopwatch On Tab Switch", parent); }
    inline void setHideStopwatchResult(bool value) { SettingsManager::set("Hide Stopwatch Result", value); }
    inline bool isHideStopwatchResult() { return SettingsManager::get("Hide Stopwatch Result").toBool(); }
    inline QString pathOfHideStopwatchResult(bool parent = false) { return SettingsManager::getPathText("Hide Stopwatch Result", parent); }
    inline void setErrorMessageColor(QString value) { SettingsManager::set("Error Message Color", value); }
    inline QString getErrorMessageColor() { return SettingsManager::get("Error Message Color").value<QString>(); }
    inline QString pathOfErrorMessageColor(bool parent = false) { return SettingsManager::getPathText("Error Message Color", parent); }
    inline void setWarnMessageColor(QString value) { SettingsManager::set("Warn Message Color", value); }
    inline QString getWarnMessageColor() { return SettingsManager::get("Warn Message Color").value<QString>(); }
    inline QString pathOfWarnMessageColor(bool parent = false) { return SettingsManager::getPathText("Warn Message Color", parent); }
    inline void setDefaultPathActionOpenFileUses(QString value) { SettingsManager::set("Default Path/Action/Open File/Uses", value); }
    inline QString getDefaultPathActionOpenFileUses() { return SettingsManager::get("Default Path/Action/Open File/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionOpenFileUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Open File/Uses", parent); }
    inline void setDefaultPathActionOpenFileChanges(QString value) { SettingsManager::set("Default Path/Action/Open File/Changes", value); }
    inline QString getDefaultPathActionOpenFileChanges() { return SettingsManager::get("Default Path/Action/Open File/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionOpenFileChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Open File/Changes", parent); }
    inline void setDefaultPathActionSaveFileUses(QString value) { SettingsManager::set("Default Path/Action/Save File/Uses", value); }
    inline QString getDefaultPathActionSaveFileUses() { return SettingsManager::get("Default Path/Action/Save File/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionSaveFileUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Save File/Uses", parent); }
    inline void setDefaultPathActionSaveFileChanges(QString value) { SettingsManager::set("Default Path/Action/Save File/Changes", value); }
    inline QString getDefaultPathActionSaveFileChanges() { return SettingsManager::get("Default Path/Action/Save File/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionSaveFileChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Save File/Changes", parent); }
    inline void setDefaultPathActionOpenContestUses(QString value) { SettingsManager::set("Default Path/Action/Open Contest/Uses", value); }
    inline QString getDefaultPathActionOpenContestUses() { return SettingsManager::get("Default Path/Action/Open Contest/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionOpenContestUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Open Contest/Uses", parent); }
    inline void setDefaultPathActionOpenContestChanges(QString value) { SettingsManager::set("Default Path/Action/Open Contest/Changes", value); }
    inline QString getDefaultPathActionOpenContestChanges() { return SettingsManager::get("Default Path/Action/Open Contest/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionOpenContestChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Open Contest/Changes", parent); }
    inline void setDefaultPathActionLoadSingleTestCaseUses(QString value) { SettingsManager::set("Default Path/Action/Load Single Test Case/Uses", value); }
    inline QString getDefaultPathActionLoadSingleTestCaseUses() { return SettingsManager::get("Default Path/Action/Load Single Test Case/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionLoadSingleTestCaseUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Load Single Test Case/Uses", parent); }
    inline void setDefaultPathActionLoadSingleTestCaseChanges(QString value) { SettingsManager::set("Default Path/Action/Load Single Test Case/Changes", value); }
    inline QString getDefaultPathActionLoadSingleTestCaseChanges() { return SettingsManager::get("Default Path/Action/Load Single Test Case/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionLoadSingleTestCaseChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Load Single Test Case/Changes", parent); }
    inline void setDefaultPathActionAddPairsOfTestCasesUses(QString value) { SettingsManager::set("Default Path/Action/Add Pairs Of Test Cases/Uses", value); }
    inline QString getDefaultPathActionAddPairsOfTestCasesUses() { return SettingsManager::get("Default Path/Action/Add Pairs Of Test Cases/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionAddPairsOfTestCasesUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Add Pairs Of Test Cases/Uses", parent); }
    inline void setDefaultPathActionAddPairsOfTestCasesChanges(QString value) { SettingsManager::set("Default Path/Action/Add Pairs Of Test Cases/Changes", value); }
    inline QString getDefaultPathActionAddPairsOfTestCasesChanges() { return SettingsManager::get("Default Path/Action/Add Pairs Of Test Cases/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionAddPairsOfTestCasesChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Add Pairs Of Test Cases/Changes", parent); }
    inline void setDefaultPathActionSaveTestCaseToAFileUses(QString value) { SettingsManager::set("Default Path/Action/Save Test Case To A File/Uses", value); }
    inline QString getDefaultPathActionSaveTestCaseToAFileUses() { return SettingsManager::get("Default Path/Action/Save Test Case To A File/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionSaveTestCaseToAFileUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Save Test Case To A File/Uses", parent); }
    inline void setDefaultPathActionSaveTestCaseToAFileChanges(QString value) { SettingsManager::set("Default Path/Action/Save Test Case To A File/Changes", value); }
    inline QString getDefaultPathActionSaveTestCaseToAFileChanges() { return SettingsManager::get("Default Path/Action/Save Test Case To A File/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionSaveTestCaseToAFileChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Save Test Case To A File/Changes", parent); }
    inline void setDefaultPathActionCustomCheckerUses(QString value) { SettingsManager::set("Default Path/Action/Custom Checker/Uses", value); }
    inline QString getDefaultPathActionCustomCheckerUses() { return SettingsManager::get("Default Path/Action/Custom Checker/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionCustomCheckerUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Custom Checker/Uses", parent); }
    inline void setDefaultPathActionCustomCheckerChanges(QString value) { SettingsManager::set("Default Path/Action/Custom Checker/Changes", value); }
    inline QString getDefaultPathActionCustomCheckerChanges() { return SettingsManager::get("Default Path/Action/Custom Checker/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionCustomCheckerChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Custom Checker/Changes", parent); }
    inline void setDefaultPathActionExportAndImportSettingsUses(QString value) { SettingsManager::set("Default Path/Action/Export And Import Settings/Uses", value); }
    inline QString getDefaultPathActionExportAndImportSettingsUses() { return SettingsManager::get("Default Path/Action/Export And Import Settings/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionExportAndImportSettingsUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Export And Import Settings/Uses", parent); }
    inline void setDefaultPathActionExportAndImportSettingsChanges(QString value) { SettingsManager::set("Default Path/Action/Export And Import Settings/Changes", value); }
    inline QString getDefaultPathActionExportAndImportSettingsChanges() { return SettingsManager::get("Default Path/Action/Export And Import Settings/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionExportAndImportSettingsChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Export And Import Settings/Changes", parent); }
    inline void setDefaultPathActionExportAndLoadSessionUses(QString value) { SettingsManager::set("Default Path/Action/Export And Load Session/Uses", value); }
    inline QString getDefaultPathActionExportAndLoadSessionUses() { return SettingsManager::get("Default Path/Action/Export And Load Session/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionExportAndLoadSessionUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Export And Load Session/Uses", parent); }
    inline void setDefaultPathActionExportAndLoadSessionChanges(QString value) { SettingsManager::set("Default Path/Action/Export And Load Session/Changes", value); }
    inline QString getDefaultPathActionExportAndLoadSessionChanges() { return SettingsManager::get("Default Path/Action/Export And Load Session/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionExportAndLoadSessionChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Export And Load Session/Changes", parent); }
    inline void setDefaultPathActionExtractAndLoadSnippetsUses(QString value) { SettingsManager::set("Default Path/Action/Extract And Load Snippets/Uses", value); }
    inline QString getDefaultPathActionExtractAndLoadSnippetsUses() { return SettingsManager::get("Default Path/Action/Extract And Load Snippets/Uses").value<QString>(); }
    inline QString pathOfDefaultPathActionExtractAndLoadSnippetsUses(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Extract And Load Snippets/Uses", parent); }
    inline void setDefaultPathActionExtractAndLoadSnippetsChanges(QString value) { SettingsManager::set("Default Path/Action/Extract And Load Snippets/Changes", value); }
    inline QString getDefaultPathActionExtractAndLoadSnippetsChanges() { return SettingsManager::get("Default Path/Action/Extract And Load Snippets/Changes").value<QString>(); }
    inline QString pathOfDefaultPathActionExtractAndLoadSnippetsChanges(bool parent = false) { return SettingsManager::getPathText("Default Path/Action/Extract And Load Snippets/Changes", parent); }
}

#endif // SETTINGSHELPER_HPP